function AccelAnalysis(varargin)
%% Create frequency response plots of shaker/acceleration data
% Usage: AccelAnalysis(); % will open a GUI

% AccelAnalysis() is used to process the data from a data acquisition
% session.  This data can be accelerometer only data or accelerometer plus
% shaker data.

% Input: a file generated by the DAQ program.  The filename is
% SHKR_yyyymmdd_hh_mm_ss.mat
% The sh matrix generated by the DAQ program provides raw accelerometer and
% configuration data.  The structure contains the following variables:
%   sh.data: the raw accelerometer and force data in column vectors.  The
%       last two fields are the force sensor and the drive signal.  The
%       accelerometer data orientation (+/- axis orientation) and 
%       calibration values are detailed in the sh.accelArray field.
%       The accelerometer data is in units of Volts.
%   sh.time: the time vector in seconds.
%   sh.windSpeed: periodically, the windspeed from IFA is read (if
%       available)
%   sh.datTim: the date time array at the start of data acquisition
%       The filename is SHKR_ followed by the date as YYYYMMDD_hh_mm_ss.
%   sh.accelArray: a cell array describing the accelerometer configuration
%       and orientation.
%   sh.source: the drive signal sent to the shaker in Volts (if a shaker
%     was used).
%   sh.FSCalib: the calibration value for the force sensor (if a shaker
%     was used).
%   sh.fs: the sample frequency in Hz.
%   sh.sweep: the frequency of the sweep vector.
%   sh.notes: a description of the contents of the sh structure.

% Output: if a shaker was used the output is a file containing a structure
% named SHKR with the following variables:
%   SHKR.H1: the H1 FRF estimator
%   SHKR.H2: the H2 FRF estimator
%   SHKR.Gff: the force sensor autospectrum
%   SHKR.Gxx: the response autospectrum
%   SHKR.Gfx: the force/response cross spectrum
%   SHKR.coherence: the force/response coherence
%   SHKR.fvec: the frequency vector for the above
%   SHKR.fres: the frequency resolution
%   SHKR.win: the window used for the analysis
%   SHKR.shakerPos: position name of the shaker
%   SHKR.shakerOrient: orientation of the shaker
%   SHKR.shakerInfo: other information entered about the shaker
%   SHKR.sourceFile: file name of the source data (sh structure)
%   SHKR.imagMotion: the time data file used for the analysis

% Functions required:
%   HPfilter()
%   accelCalibrate()
%   accelOrient()
%   discIntgrt()
%   M1imageMotion()
%   M2imageMotion()
%   Hcalc()
%       winFFT()
%           winSeg()
%           winGen()

% Written by Bill McBride Jan 21 2015
% Update Apr 13 2015:
% Changed to use structure generated by new DAQ program
% Removed coude rigid body calculations
% Update 11 May 2015:
% Ditched use of mscohere function, changed to properly use PSD auto and
% cross correlations.
% Update 13 May 2015:
% Divided script into functions and cleaned up the code
% Update 25 Aug 2015:
% Corrected the instructions and input/output information

% Update 28 Aug 2018
% Added check to verify that sh structure is in the opened file
% Combined two programs: jitterCalc and ShakerCalcFRF into this one
% program.
% pulled the coude image motion routine into this function and made the
% location of the accelerometers flexible.

% Update 29 Aug 2018
% Gave up on making a reasonable program flow and made into a GUI

% Update 6 Dec 2018
% made checkboxes invisible unless they are being used
% added log() function to display Message
% added text boxes for min/max frequency, min max amplitude, start/stop
% time.

%% GUI Setup
  close all; % remove this after debugging %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % set up the directories
  % we assume the graphics stuff is at the same directory level
  % and add it to the MATLAB path
  
  currentPath = pwd; % get current path
  currentFolders = split(currentPath, "/"); % get the folders in the path
  lastFolderIdx = length(currentFolders); % get last folder index
  currentFolder = currentFolders{lastFolderIdx,1}; % get name of current folder
  
  % if the current folder is not MainFuctions, find the right directory
  switch currentFolder
    case 'MainFunctions'
      
    case 'MatlabRepository'
      cd MainFunctions
    otherwise
      disp('cannot find directory /MainFunctions')
      disp(['It might be here: ',which('AccelAnalysis')])
      return     
  end

  parentDir = cd; % get path
  parentDir = fullfile(parentDir, '..');
  graphicsDir = fullfile(parentDir, 'graphicsFunctions');
  addpath(graphicsDir);
  dataDir = fullfile(parentDir, 'dataDir');
  addpath(dataDir);
  
  %% Create the GUI figure
  big = figure('Visible', 'off',...
    'Units', 'pixels',...
    'Position', [100 100 1440 850]);
  big.CloseRequestFcn = @closeReqCallback;
  fntSz = 10;
  
  %% Create the File container - top
  filePanel = uipanel('Parent',big);
  filePanel.Units = 'pixels';
  filePanel.Position = [10, 750, 980, 100];
  filePanel.Title = 'File, Plot, Output';
  filePanel.FontSize = fntSz;
  
  % data file button and text field
  noFileText = 'no file selected                                       ';
  fileEntry = MTextField(filePanel, noFileText);
  fileLabel = MLabel(filePanel, 'Data file');
  fileEntry.addLabel(fileLabel, 'left');
  fileEntry.moveTo(50, 50);
  
  fileButton = MButton(filePanel, 'Open file...');
  fileButton.moveTo(250, 50);
  fileButton.setCallback({@fileButtonCallback, fileEntry});
  
  makePlotsButton = MButton(filePanel, 'Make Plots');
  makePlotsButton.moveTo(350, 50);
  makePlotsButton.setCallback({@makePlotsButtonCallback, fileEntry});
  
  % message window
  messageEntry = MTextField(filePanel, 'no open file                                                                  ');
  messageLabel = MLabel(filePanel, 'Message');
  messageEntry.addLabel(messageLabel, 'left');
  messageEntry.moveTo(50, 20);
  
  % Apply Budget checkbox
  budCheck = MCheckBox(filePanel, 'Apply Vibration Budget');
  budCheck.setCallback({@budCheckCallback, budCheck});
  budCheck.moveTo(350, 20);
  budCheck.setSelected(0);
  budCheck.setVisible('on');
  
  % Vib Budget amplitude textbox
  vibBudLabel = MLabel(filePanel, 'Vibration Budget Amplitude (mas)');
  vibBudEntry = MTextField(filePanel, 140);
  vibBudEntry.addLabel(vibBudLabel, 'right');
  vibBudEntry.moveTo(500, 20);
  vibBudEntry.Control.Enable = 'off';
  vibBudEntry.setCallback({@vibBudCallback, vibBudEntry});
  
  %% Create the Data Configuration container - mid left
  dataInfoPanel = uipanel(big);
  dataInfoPanel.Units = 'pixels';
  dataInfoPanel.Position = [10, 600, 320, 150];
  dataInfoPanel.Title = 'Data Configuration';
  dataInfoPanel.FontSize = fntSz;
  
  shakerLabel = MLabel(dataInfoPanel, 'Shaker data: ');
  shakerLabel.moveTo(10, 110);
  shakerValue = MLabel(dataInfoPanel, 'Unknown');
  shakerValue.moveTo(70, 110);
  
  fsLabel = MLabel(dataInfoPanel, 'Sample freq:');
  fsLabel.moveTo(10, 90);
  fsValue = MLabel(dataInfoPanel, 'unknown');
  fsValue.moveTo(70, 90);
  
  %% Create the Plot Configuration container (mid mid)
  PlotConfigPanel = uipanel(big);
  PlotConfigPanel.Units = 'pixels';
  PlotConfigPanel.Position = [340, 600, 320, 150];
  PlotConfigPanel.Title = 'Plot Configuration';
  PlotConfigPanel.FontSize = fntSz;
  
  validPlots = {'H1/H2','H1','H2','Gff/Gxx','Gff','Gxx','Gfx'};
  plotTypeCombo = MComboBox(PlotConfigPanel, validPlots);
  plotTypeCombo.setSelectedIndex(1);
  plotTypeLabel = MLabel(PlotConfigPanel, 'Plot Type');
  plotTypeCombo.addLabel(plotTypeLabel,'left');
  plotTypeCombo.moveTo(60, 110);
  plotTypeCombo.setCallback({@plotTypeCallback, plotTypeCombo});
  
  % FFT window selection
  validWindows = {'Rectang', 'Hanning', 'Hamming', 'BlackmanHarris',...
    'Nuttall3', 'Nuttall3a', 'Nuttall3b', 'Nuttall4', 'Nuttall4a',...
    'Nuttall4b', 'Nuttall4c', 'HFT70', 'HFT95', 'HFT90D', 'HFT116D',...
    'HFT144D', 'HFT169D', 'HFT196D', 'HFT223D', 'HFT248D'};
  winSelect = 'HFT95';
  windowCombo = MComboBox(PlotConfigPanel, validWindows);
  windowCombo.setSelectedIndex(13);
  windowLabel = MLabel(PlotConfigPanel, 'Window');
  windowCombo.addLabel(windowLabel,'left');
  windowCombo.moveTo(60, 80);
  windowCombo.setCallback({@windowCallback, windowCombo});
  
  % FFT resolution box
  fResLabel = MLabel(PlotConfigPanel, 'Freq Res');
  fResEntry = MTextField(PlotConfigPanel, 0.01);
  fResEntry.addLabel(fResLabel, 'left');
  fResEntry.moveTo(60, 50);
  fResEntry.setCallback({@fResCallback, fResEntry});
  
  % Plot Data box
  validTypes = {'Displacement','Velocity','Acceleration'};
  dTypeSelect = 'Displacement';
  dTypeCombo = MComboBox(PlotConfigPanel, validTypes);
  dTypeCombo.setSelectedIndex(1);
  dTypeLabel = MLabel(PlotConfigPanel, 'Plot Data');
  dTypeCombo.addLabel(dTypeLabel,'left');
  dTypeCombo.moveTo(60, 20);
  dTypeCombo.setCallback({@dTypeCallback, dTypeCombo});
  
  %% Create the Plot Info container - mid right
  plotInfoPanel = uipanel(big);
  plotInfoPanel.Units = 'pixels';
  plotInfoPanel.Position = [670, 600, 320, 150];
  plotInfoPanel.Title = 'Plot Info';
  plotInfoPanel.FontSize = fntSz;  
  
  maxLvlLabel = MLabel(plotInfoPanel, 'Maximum Amplitude: ');
  maxLvlLabel.moveTo(10, 110);
  maxLvlValue = MLabel(plotInfoPanel, 'unknown');
  maxLvlValue.moveTo(130,110);
  
  avgLvlLabel = MLabel(plotInfoPanel, 'Average Amplitude: ');
  avgLvlLabel.moveTo(10, 90);
  avgLvlValue = MLabel(plotInfoPanel, 'unknown');
  avgLvlValue.moveTo(130,90);
  
  durationLabel = MLabel(plotInfoPanel, 'Duration: ');
  durationLabel.moveTo(10, 70);
  durationValue = MLabel(plotInfoPanel, 'unknown');
  durationValue.moveTo(130,70);
  
  %% Create the Plot container - bottom
  plotPanel = uipanel(big);
  plotPanel.Units = 'pixels';
  plotPanel.Position = [10, 10, 980, 590];
  plotPanel.Title = 'Time Plot Configuration';
  plotPanel.FontSize = fntSz;
  
  accelTable = MTable(plotPanel);
  accelTable.setColumnHeaders({'DAQ ch','serNum','Loc','Orient','inv'});
  accelTable.anchorAtTop;
  
  sldrLt = uicontrol(plotPanel, 'Style', 'slider',...
    'Position', [530 250 120 20],...
    'Callback', @sliderLeftCallback);
  
  sldrRt = uicontrol(plotPanel, 'Style', 'slider',...
    'Position', [800 250 120 20],...
    'Callback', @sliderRightCallback);
  
  % Time Min text box
  tMinLabel = MLabel(plotPanel, 'Start');
  tMinEntry = MTextField(plotPanel, '');
  tMinEntry.addLabel(tMinLabel, 'left');
  tMinEntry.moveTo(560, 280);
  tMinEntry.setCallback({@tMinCallback, tMinEntry});
  
  % Time Max text box
  tMaxLabel = MLabel(plotPanel, 'End');
  tMaxEntry = MTextField(plotPanel, '');
  tMaxEntry.addLabel(tMaxLabel, 'left');
  tMaxEntry.moveTo(850, 280);
  tMaxEntry.setCallback({@tMaxCallback, tMaxEntry});
     
  % create top plot window
  hPlotTopAx = axes(plotPanel,...
    'Units','pixels',...
    'Position',[560,320,350,200]);
  
  % create bottom plot window
  hPlotBotAx = axes(plotPanel,...
    'Units','pixels',...
    'Position',[550,40,350,200]);
  
  % create plot button
  plotButton = MButton(plotPanel, ' Update Plots ');
  plotButton.moveTo(550, 540);
  plotButton.setCallback({@plotButtonCallback});
  plotButton.Control.UserData = 0; % will use for number of channels
  
  for boxCount = 1:34
    accelSelect(boxCount) = MCheckBox(plotPanel, num2str(boxCount));
    accelSelect(boxCount).Control.Visible = 0;
  end
  
  %% Create the Frequency Plot container - right
  FftPlotPanel = uipanel(big);
  FftPlotPanel.Units = 'pixels';
  FftPlotPanel.Position = [1000, 10, 430, 840];
  FftPlotPanel.Title = 'FFT Plot Configuration';
  FftPlotPanel.FontSize = fntSz;
  
  % create top FFT plot window
  topPos = [50,590,350,200];
  hFftTopAx = axes(FftPlotPanel,...
    'Units','pixels',...
    'Position',topPos);
  
  % create middle FFT plot window
  midPos = [50,300,350,200];
  hFftMidAx = axes(FftPlotPanel,...
    'Units','pixels',...
    'Position',midPos);
  
  % create bottom FFT plot window
  botPos = [50,40,350,200];
  hFftBotAx = axes(FftPlotPanel,...
    'Units','pixels',...
    'Position',botPos);
  
  fsldrLt = uicontrol(FftPlotPanel, 'Style', 'slider',...
    'SliderStep', [0.0001 0.001],...
    'Position', [50 520 120 20],...
    'Callback', @fsliderLeftCallback);
  
  fsldrRt = uicontrol(FftPlotPanel, 'Style', 'slider',...
    'Position', [280 520 120 20],...
    'Callback', @fsliderRightCallback); 
  
  % Freq Min resolution box
  fMinLabel = MLabel(FftPlotPanel, 'Freq Min');
  fMinEntry = MTextField(FftPlotPanel, '');
  fMinEntry.addLabel(fMinLabel, 'left');
  fMinEntry.moveTo(150, 550);
  fMinEntry.setCallback({@fMinCallback, fMinEntry});
  
  % Freq Max resolution box
  fMaxLabel = MLabel(FftPlotPanel, 'Freq Max');
  fMaxEntry = MTextField(FftPlotPanel, '');
  fMaxEntry.addLabel(fMaxLabel, 'left');
  fMaxEntry.moveTo(330, 550);
  fMaxEntry.setCallback({@fMaxCallback, fMaxEntry});
  
  % Ampl Min resolution box
  aMinLabel = MLabel(FftPlotPanel, 'Min');
  aMinEntry = MTextField(FftPlotPanel, '');
  aMinEntry.addLabel(aMinLabel, 'left');
  aMinEntry.moveTo(30, 550);
  aMinEntry.setCallback({@aMinCallback, aMinEntry});
  
  % Ampl Max resolution box
  aMaxLabel = MLabel(FftPlotPanel, 'Max');
  aMaxEntry = MTextField(FftPlotPanel, '');
  aMaxEntry.addLabel(aMaxLabel, 'left');
  aMaxEntry.moveTo(30, 800);
  aMaxEntry.setCallback({@aMaxCallback, aMaxEntry});
  
  big.Visible = 'on'; % make GUI visible  

  %% Open file
  % the GUI doesn't really do much until the file is open
  % then it populates the gui fields and buttons
  function fileButtonCallback(button, ~, fileEntry)

  % save the current directory and go to the data directory and get
  % filename.
  oldDir = cd('../dataDir'); 
  [fileName, pathName, index] = uigetfile('*.mat', 'Select data file');
  
  if ~index % No file was selected
    warning('No file selected')
    return;
  else
    fileEntry.setText(fileName); % set text box to display the file name
    % messageEntry.setText('opening file');
    log('opening file');

    load([pathName fileName],'sh');
    if ~exist('sh', 'var') % see if the sh structure is in the workspace
      warning(['sh structure not found in file ',fileName])
      return; % if not, bail out
    end
  end
  cd(oldDir); % go back to original directory
  
  % if we got to here, the file was opened and contains the sh structure
  log('file open success');
  
  % clear any plots from previous runs
  cla(hPlotTopAx);
  cla(hPlotBotAx);
  cla(hFftTopAx);
  cla(hFftMidAx);
  cla(hFftBotAx);
  
  % clear the boxes in case a file was open with more accels
  for boxes = 1:34
    accelSelect(boxes).Control.Visible = 0;
  end
  
  % look to see if there is shaker data in the file
  if isfield(sh, 'source')
    isShaker = true;
    shakerValue.setText('Yes');
  else
    isShaker = false;
    shakerValue.setText('No');
  end
   
  % update sample frequency value from data
  fsValue.setText([num2str(sh.fs),' Hz']);
  
  % read accelArray and make a table of the info
  accArr(:,1) = num2cell(sh.accelArray{1,1});
  accArr(:,2) = num2cell(sh.accelArray{1,2});
  accArr(:,3) = sh.accelArray{1,3};
  accArr(:,4) = sh.accelArray{1,4};
  accArr(:,5) = sh.accelArray{1,5};
  
  % check to see if accelArray contains acclerometer names that can be used
  % to plot image motion
  [m1, m2, cde] = imageMotCheck(accArr);
  
  % number of channels is 2 more for shaker data
  numAccels = length(sh.accelArray{1,1});
  numChannels = length(sh.data(1,:));

  log('calibrating accel data');

  % scale the accelerometer data to units of m/s^2
  acceleration = accelCalibrate(sh.data(:,1:numAccels), sh.accelArray);

  % align the polarity of the accelerometer data to the coordinate axes
  acceleration = accelOrient(acceleration, sh.accelArray);
  
  log('filtering accel data');

  fFilt = 1; % put this in a button %%%%%%%%%%%%%%%%%%%%%%%%%%%
  % create velocity and displacement vectors from acceleration vector
  [velocity, displacement] = discIntgrt(acceleration,sh.fs,fFilt);
  displacement = detrend(displacement);
  
  % save acceleration, velocity, displacement, time vectors to guidata
  d.acc = acceleration;
  d.vel = velocity;
  d.disp = displacement;
  d.time = sh.time;
  d.fs = sh.fs;
  
  % check to see if time at beginning is not 0
  % if so, remove it
  if d.time(1,1) ~= 0
    d.time = d.time - d.time(1,1);
  end
  
  % populate the table
  accelTable.setData(accArr);
 
  % if there is a shaker, add the drive and force rows to the table and
  % calibrate the force sensor data
  if isShaker
    accelTable.addRow({numAccels,' ','force',' ',' '});
    accelTable.addRow({numAccels+1,' ','drive',' ',' '});
    forceChannel = numAccels + 1;
    driveChannel = numAccels + 2;
    log('calibrating force data');
    d.force = sh.data(:,forceChannel) * sh.FSCalib;
    d.drive = sh.data(:,driveChannel);
    d.isShaker = true;
    d.actv = horzcat(displacement,d.force,d.drive);
    log('calibration complete');    
  else
    d.isShaker = false;
    d.actv = displacement;
  end
  %{
  hFig = button.Parent.Parent; % handle to GUI figure
  guidata(hFig,d) % save structure to guidata variable in figure
  %}
  guidata(big,d); % save structure to guidata variable in figure

  % figure out where to put the checkboxes in relation to the table
  findCorner = accelTable.getPosition;
  widPos = findCorner(1) + findCorner(3) + 10;
  hghtPos = findCorner(2) + findCorner(4) -40;
  
  % Create the check boxes next to each channel in the table.
  % 34 checkboxes were created when the gui was built so that the
  % accelSelect array is shared between all sub-functions. This is called
  % nested callback functions - variables are shared between the
  % subfunctions of the parent function.

  for boxCnt = 1:numChannels
    %accelSelect(boxCnt) = MCheckBox(plotPanel, num2str(boxCnt));
    accelSelect(boxCnt).setCallback({@accCheckCallback, accelSelect(boxCnt)});
    accelSelect(boxCnt).moveTo(widPos, hghtPos + 19 - (17 * boxCnt));
    accelSelect(boxCnt).setSelected(0);
    accelSelect(boxCnt).Control.Visible = 1;
  end

  % stash the number of channels into the UserData of the plot button to
  % make it easily accessable to the callback functions
  plotButton.Control.UserData = numChannels;
  
  % set the min, max, and set values of the sliders based on the length of
  % the open data file
  sldrLt.Min = min(d.time);
  sldrLt.Max = max(d.time);
  sldrLt.Value = min(d.time);
  
  sldrRt.Min = min(d.time);
  sldrRt.Max = max(d.time);
  sldrRt.Value = max(d.time);
  
  % set the frequency sliders min, max and value
  nyqFreq = floor(sh.fs/2); % nyquist frequency (max value of freq plots)
  fsldrLt.Min = 0.1;
  fsldrLt.Max = nyqFreq;
  fsldrLt.Value = 0.1;
  
  fsldrRt.Min = 0.1;
  fsldrRt.Max = nyqFreq;
  fsldrRt.Value = nyqFreq;
  
  fMaxEntry.Control.UserData = nyqFreq;
    
  end

%% General purpose functions

  function updatePlot
  % called by the 'Update Plots' button or the sliders
  % updates the plot axes
  
    log('plotting');
    % read the plot type combo box
    plotStyle = plotTypeCombo.getSelectedItem;
    % retreive the data stored in the guidata variable
    dat = guidata(big);
    % read all of the checkboxes and return the logical matix (cks.xx)
    numCh = plotButton.Control.UserData;
    for chkCnt = 1:numCh
      cks(chkCnt) = accelSelect(chkCnt).isSelected;
    end

    % plot if one or more boxes are checked, else clear axes and return
    if isequal(zeros(size(cks)),cks)
      cla(hPlotTopAx);
      cla(hPlotBotAx);
      return;
    end
    % plot all checked data in top axis
    cla(hPlotTopAx);
    hTopPlot = plot(hPlotTopAx,dat.time,dat.actv(:,cks));
    
    % measure the amplitude of the plot data so the cursors can be set to
    % the right height.
    yl = hPlotTopAx.YLim;
        
    % add cursors
    lCur = sldrLt.Value;
    rCur = sldrRt.Value;
    line(hPlotTopAx, [lCur lCur], [yl(1) yl(2)],'Color','red')
    line(hPlotTopAx, [rCur rCur], [yl(1) yl(2)],'Color','red')
    % find the indices of the cursor frequency
    lIdx = round(lCur * dat.fs);
    rIdx = round(rCur * dat.fs);
    % don't let the time vector be shorter than 100 samples
    
    maxIdx = floor(sldrRt.Max * dat.fs);
    
    if rIdx > maxIdx
      rIdx = maxIdx;
    end
    if lIdx < 1
      lIdx = 1;
    end
    
    % make sure sliders stay in bounds    
    % if indices are closer than 100 and we are not at end
    if rIdx - lIdx < 100 && rIdx + 100 < maxIdx
      rIdx = rIdx + 100;
    end
    if rIdx - lIdx < 100 && lIdx - 100 > 1
      lIdx = lIdx - 100;
    end
    
    % label axis
    hPlotTopAx.Title.String = 'Time';
    
    % plot zoomed data in bottom axis
    hBotPlot = plot(hPlotBotAx,dat.time(lIdx:rIdx,1),...
      dat.actv(lIdx:rIdx,cks));
    % label axis
    hPlotBotAx.Title.String = 'Zoom';
    
    % determine if requested freq resolution is possible
    maxFRes = dat.fs/length(dat.time(lIdx:rIdx,1)) * 1.01; % 1% larger
    if str2double(fResEntry.getText) < maxFRes
      log(['Freq res below minimum. Adjusting to: ',...
        num2str(maxFRes),' Hz'])
      fResEntry.setText(maxFRes);
    end        
    
    % create FFT plot
    fres = str2double(fResEntry.getText);
    winType = windowCombo.getSelectedItem;
    
    
    dataToPlot = dat.actv(:,cks);
    [~,numFFTs] = size(dataToPlot);
    %fdat = zeros(len, numFFTs);
    for calcs = 1:numFFTs
      [fdat(:,calcs),fvec,~] = winFFT(dataToPlot(lIdx:rIdx,calcs),dat.fs,'LS',winType,'fres',fres);
    end
    % find the indices of the frequency vector
    fIdxLow = find(fvec > fsldrLt.Value, 1, 'first');
    fIdxHi = find(fvec < fsldrRt.Value, 1, 'last');
    fvecLen = length(fvec);
   
    % make sure sliders don't get closer than 10 freq steps
    if fIdxHi - fIdxLow < 10
      fIdxHi = fIdxHi + 5;
      fIdxLow = fIdxLow - 5;
    end
    
    % make sure sliders stay in bounds
    if fIdxHi > fvecLen
      fIdxHi = fvecLen;
    end
    if fIdxLow < 1
      fIdxLow = 1;
    end
    
    cla(hFftTopAx);
    plot(hFftTopAx,fvec(fIdxLow:fIdxHi,1),fdat(fIdxLow:fIdxHi,:));
    
    % add vibration budget to plot if checkbox checked
    % this needs to be moved to a different plot *************************
    % as it only applies to image motion units
    if budCheck.isSelected
      lims = [0.02, 0.02, 2, 2, 1, 1]; % normalized vib budget amplitude
      freqs = [0.02, 0.4, 75, 190, 300, 1000]; % vib budget frequencies
      budVal = str2double(vibBudEntry.getText); % get vibration budget scale
      lims = lims .* budVal; % scale vibration budget
      hold on;
      plot(hFftTopAx,freqs,1./lims,'--','color','red')
      hold off;
    end
    
    hFftTopAx.XScale = 'log';
    hFftTopAx.YScale = 'log';    

    % label axis
    hFftTopAx.Title.String = 'Amplitude FFT';
    
    % measure the amplitude of the plot data so the cursors can be set to
    % the right height.
    fyl = hFftTopAx.YLim;
        
    % add cursors
    flCur = fsldrLt.Value;
    frCur = fsldrRt.Value;
    line(hFftTopAx, [flCur flCur], [fyl(1) fyl(2)],'Color','red')
    line(hFftTopAx, [frCur frCur], [fyl(1) fyl(2)],'Color','red')
    flIdx = round(flCur * dat.fs);
    frIdx = round(frCur * dat.fs);
    
    % if this is a shaker session, plot the FRF
    if dat.isShaker         
      [H1,H2,Gff,Gxx,Gfx,coh,fvc] = Hcalc(dat.force(lIdx:rIdx,1),...
        dat.actv(lIdx:rIdx,cks),dat.fs,fres,winType);
      H1mag = abs(H1); % magnitude of the complex H1 vector
      H2mag = abs(H2);
      Gfxmag = abs(Gfx);
      
      whatToPlot = plotTypeCombo.getSelectedItem;
      
      switch whatToPlot
        case 'H1/H2'
          plotDat1 = H1mag;
          plotDat2 = H2mag;
          midPlotLabel = 'H1/H2 of Top Check Box';
        case 'H1'
          plotDat1 = H1mag;
          plotDat2 = '';
          midPlotLabel = 'H1 of Top Check Box';          
        case 'H2'
          plotDat1 = H2mag;
          plotDat2 = '';
          midPlotLabel = 'H2 of Top Check Box';          
        case 'Gff/Gxx'
          plotDat1 = Gff;
          plotDat2 = Gxx; 
          midPlotLabel = 'Gff/Gxx of Top Check Box';          
        case 'Gff'
          plotDat1 = Gff;          
          plotDat2 = '';  
          midPlotLabel = 'Gff of Top Check Box';          
        case 'Gxx'
          plotDat1 = Gxx;          
          plotDat2 = '';
          midPlotLabel = 'Gxx of Top Check Box';          
        case 'Gfx'
          plotDat1 = Gfxmag;          
          plotDat2 = '';
          midPlotLabel = 'Gfx of Top Check Box';          
      end

      if strcmp(plotDat2,'')
        hFftMidPlot = loglog(hFftMidAx,fvc(fIdxLow:fIdxHi,1),...
          plotDat1(fIdxLow:fIdxHi,1));
        assignin('base','dat1',plotDat1); % save to base workspace
        assignin('base','fvc',fvc);
      else
        hFftMidPlot = loglog(hFftMidAx,fvc(fIdxLow:fIdxHi,1),...
          plotDat1(fIdxLow:fIdxHi,1),fvc(fIdxLow:fIdxHi,1),...
          plotDat2(fIdxLow:fIdxHi,1));
        assignin('base','dat1',plotDat1); % save to base workspace
        assignin('base','dat2',plotDat2);
        assignin('base','fvc',fvc);
      end
      
      hFftBotPlot = plot(hFftBotAx,fvc(fIdxLow:fIdxHi,1),...
        coh(fIdxLow:fIdxHi,1));
      hFftBotAx.XScale = 'log';
      hFftBotAx.Title.String = 'Coherence of Top Check Box';
      hFftMidAx.Title.String = midPlotLabel;   
    end  

    % label all the plot axes appropriately
    switch dTypeCombo.getSelectedItem
      case 'Acceleration'
        labelAll('Time (s)','Acceleration (m/s^2)',hPlotTopAx,hPlotBotAx);
        labelAll('Frequency (Hz)','Acceleration (m/s^2)',hFftTopAx,...
          hFftMidAx, hFftBotAx);
      case 'Velocity'
        labelAll('Time (s)','Velocity (m/s)',hPlotTopAx,hPlotBotAx);
        labelAll('Frequency (Hz)','Velocity (m/s)',hFftTopAx,...
          hFftMidAx, hFftBotAx);
      case 'Displacement'
        labelAll('Time (s)','Displacement (m)',hPlotTopAx,hPlotBotAx);
        labelAll('Frequency (Hz)','Displacement (m)',hFftTopAx);
        labelAll('Frequency (Hz)','FRF (m/N)',hFftMidAx);
        labelAll('Frequency (Hz)','Coherence',hFftBotAx);        
      otherwise
        error('there was a screwup with Plot Data combo box')
    end
    
    % turn on the grid lines
    gridAllOn(hPlotTopAx, hPlotBotAx, hFftTopAx, hFftMidAx, hFftBotAx)
    
    if ~isempty(aMinEntry.getText)
      lowLim = str2double(aMinEntry.getText);
      hPlotTopAx.YLim(1,1) = lowLim;
      hPlotBotAx.YLim(1,1) = lowLim;
      hFftTopAx.YLim(1,1) = lowLim;
      hFftMidAx.YLim(1,1) = lowLim;
    end
      
    if ~isempty(aMaxEntry.getText)
      hiLim = str2double(aMaxEntry.getText);
      hPlotTopAx.YLim(1,2) = hiLim;
      hPlotBotAx.YLim(1,2) = hiLim;
      hFftTopAx.YLim(1,2) = hiLim;
      hFftMidAx.YLim(1,2) = hiLim;
    end
         
    % update the values in the Plot Info panel
    maxLvlValue.setText(max(max(dat.actv(lIdx:rIdx,cks))));
    avgLvlValue.setText(mean(rms(dat.actv(lIdx:rIdx,cks))));
    durationValue.setText([num2str(dat.time(rIdx,1) - dat.time(lIdx,1)),' s']);
    
    % identify the axis for use in callback functions
    hFftTopAx.UserData = 'top';
    hFftMidAx.UserData = 'mid';
    hFftBotAx.UserData = 'bot';
    
    % callbacks for left mouse click on axes
    hFftTopAx.ButtonDownFcn = @clickAxCallback;
    hFftMidAx.ButtonDownFcn = @clickAxCallback;
    hFftBotAx.ButtonDownFcn = @clickAxCallback;
    
    log('plot complete');
  end

  % read and update all of the checkboxes
  function accReadBoxes
    numCh = plotButton.Control.UserData;
    for chkCnt = 1:numCh
      accelSelect(chkCnt).isSelected;
    end
  end

  function log(msgString)
    messageEntry.setText(msgString);
    drawnow
  end

  function gridAllOn(varargin)
    % send me a bunch of axes and I'll turn on their grids
    for counter = 1:nargin
      varargin{counter}.XGrid = 'on';
      varargin{counter}.YGrid = 'on';
      varargin{counter}.XMinorGrid = 'on';
      varargin{counter}.YMinorGrid = 'on';
    end
  end

  function labelAll(xLabel,yLabel, varargin)
    % send me a bunch of axes and I'll stick labels on them
    for counter = 1:nargin
      varargin{counter}.XLabel.String = xLabel;
      varargin{counter}.YLabel.String = yLabel;
    end
  end

  % check to see if all the necessary accels are present to calculate image
  % motion
  function [m1, m2, cde] = imageMotCheck(accArr)
    m1 = false;
    m2 = false;
    cde = false;
    
    % get the accleromter names
    names = string(accArr(:,3));
    
    yesM1 = isItThere(names,["M1px", "M1mx", "M1my"]);
 
    % make a function that compares the strings to see if all are present
    function isIn = isItThere(names,varargin)
      numNames = nargin;
      % need to figure out if all the varargins are in names here
      %&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
      
      
      
      
      isIn = false;
      
    end
    
    %{
    switch names
      case {'Cmx','Cmy','Cmz'}
    disp('coude accels found');
      case {'M1px', 'M1mx', 'M1my'}
        disp('M1 accels found')
      case {'M2mx', 'M2px', 'M2pz'}
        disp('M2 accels found')
      case {'M5x', 'M5y', 'M5z'}
        disp('M2 accels found')
      otherwise
        disp('no image motion accels found')
    end
  %}
    
  end


%% GUI callbacks
  function plotButtonCallback(~,~,~)
    % updatePlot is called by multiple means so we don't duplicate the
    % function here 
    updatePlot;
  end

  function budCheckCallback(~,~,check)
    if check.isSelected
      vibBudEntry.Control.Enable = 'on';
    else
      vibBudEntry.Control.Enable = 'off';
    end
  end
  
  function vibBudCallback(~,~,vibBud)
    disp(vibBud.getText)
  end

  function plotTypeCallback(~,~,plotType)
    log([plotType.getSelectedItem, ' selected']);
  end

  function windowCallback(~, ~, win)
    winSelect = win.getSelectedItem();
    log([winSelect, ' selected']);
  end

  function fResCallback(~,~,fRes)
    disp(fRes.getText)
  end

  function fMinCallback(~,~,fMin)
    fsldrLt.Value = str2double(fMin.getText);
    updatePlot; 
  end

  function fMaxCallback(~,~,fMax)
    % check to make sure the entry doesn't exceep the Nyquist freq.
    if str2double(fMax.getText) > fMaxEntry.Control.UserData
      fMax.setText(num2str(fMaxEntry.Control.UserData));
      log('Freq Max entry exceeded nyquist freq')
    elseif str2double(fMax.getText) < 0
      fMax.setText('0');
    end
    fsldrRt.Value = str2double(fMax.getText);
    updatePlot;
  end

  function aMinCallback(~,~,aMin)
    disp(aMin.getText)
    updatePlot;
  end

  function aMaxCallback(~,~,aMax)
    disp(aMax.getText)
    updatePlot;
  end

  function tMinCallback(~,~,tMin)
    disp(tMin.getText)
    sldrLt.Value = str2double(tMin.getText);
    updatePlot; 
  end

  function tMaxCallback(~,~,tMax)
    disp(tMax.getText)
    sldrRt.Value = str2double(tMax.getText);
    updatePlot;
  end

  function dTypeCallback(~,~,dType)
    dat = guidata(big);
    disp(dType.getSelectedItem)
    switch dType.getSelectedItem
      case 'Acceleration'
        dat.actv = dat.acc;
      case 'Velocity'
        dat.actv = dat.vel;
      case 'Displacement'
        dat.actv = dat.disp;
      otherwise
        error('there was a screw up with Plot Data combo box')
    end
    guidata(big,dat); 

  end

  function [imagMotion] = convM2(displacement)
    warning('convM2 function not written yet')
    imagMotion = displacement;
  end

  % callback for plot check boxes
  function accCheckCallback(~, ~, ~)
    accReadBoxes;
  end

  % time sliders
  function sliderLeftCallback(~, ~)
    if sldrLt.Value > sldrRt.Value
      sldrLt.Value = sldrRt.Value;
    end
    tMinEntry.setText(sldrLt.Value);
    updatePlot;
  end
  
  function sliderRightCallback(~, ~)
    if sldrRt.Value < sldrLt.Value
      sldrRt.Value = sldrLt.Value;
    end
    tMaxEntry.setText(sldrRt.Value);
    updatePlot;
  end

  % frequency sliders
  function fsliderLeftCallback(~, ~)
    if fsldrLt.Value > fsldrRt.Value
      fsldrLt.Value = fsldrRt.Value;
    end
    % update text box with slider value
    fMinEntry.setText(fsldrLt.Value);
    updatePlot;
  end
  
  function fsliderRightCallback(~, ~)
    if fsldrRt.Value < fsldrLt.Value
      fsldrRt.Value = fsldrLt.Value;
    end
    fMaxEntry.setText(fsldrRt.Value);
    updatePlot;
  end

  function makePlotsButtonCallback(~, ~, ~)
  % when the "Make Plots" button is pressed: plot all the accels FRF and
  % save the plots
    log('generating plots')
    prompt = 'Enter filename for plots (hint: shaker loc and orient helps)';
    locName = inputdlg(prompt,'Plot Filename');
    if isempty(locName)
      locName = 'no_name';
    else
      locName = locName{1,1};
    end
    
    dat = guidata(big);
    
    if ~dat.isShaker
      return;
    end
    
    aTable = accelTable.getData;
    
    % get name of raw SHKR file
    [~, sesName, ~] = fileparts(fileEntry.getText);
    
    posCount = 1;
    %for plotCount = 1:length(accelSelect)-4
    % I'm not sure why I used the above line - changed to the below line
    for plotCount = 1:length(aTable)
      
      log(['calculating plot ',num2str(plotCount)])
      fres = 0.01;
      winType = 'HFT95';
      [H1,H2,~,~,~,~,fvc] = Hcalc(dat.force(:,1),...
        dat.actv(:,plotCount),dat.fs,fres,winType);
      
      lIdx = 1;      
      rIdx = round(length(fvc)./4);
      
      H1mag = abs(H1); % magnitude of the complex H1 vector
      H2mag = abs(H2);
      
      plotDat1 = H1mag;
      plotDat2 = H2mag;
      
      switch plotCount
        case 1
          figPage1 = figure('Name',[locName,'_',sesName],...
            'Position', [40 50 1440 850]); 
        case 10
          posCount = 1;
          figPage2 = figure('Name',[locName,'_',sesName],...
            'Position', [60 70 1440 850]);
        case 19
          posCount = 1;
          figPage3 = figure('Name',[locName,'_',sesName],...
            'Position', [80 90 1440 850]);
        case 28
          posCount = 1;
          figPage4 = figure('Name',[locName,'_',sesName],...
            'Position', [100 110 1440 850]);
      end
         
      subplot(3,3,posCount);
      loglog(fvc(lIdx:rIdx,1),...
      plotDat1(lIdx:rIdx,1),...
      fvc(lIdx:rIdx,1),...
      plotDat2(lIdx:rIdx,1));
      axis tight;
      
      % @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
      % add analysis code here and put into above plot
      % frequency weighted funcion is in AOcorrection.m
      % frequency weight and plot new lines? or have option box for AO
      % corrected?
      % see SPIE paper for technique
      
      title([aTable{plotCount,3},aTable{plotCount,4}]);
      legend('H1', 'H2');
      xlabel('Freq (Hz)')
      ylabel({locName,'FRF (m/N)'},'Interpreter','none')
      xlim([5 100]) % min and max frequency to plot

      ax = gca;
      ax.XGrid = 'on';
      ax.YGrid = 'on';
      ax.XMinorGrid = 'on';
      ax.YMinorGrid = 'on';
    
      posCount = posCount + 1;    
    end
    
    log('saving plots')
    saveas(figPage1,[locName,'_pg1.png']);
    saveas(figPage2,[locName,'_pg2.png']);
    saveas(figPage3,[locName,'_pg3.png']);
    saveas(figPage4,[locName,'_pg4.png']);
    log('save complete')
  end

  function closeReqCallback(~, ~)
    delete(gcf);
  end

  function clickAxCallback(src, ~)
    % if figure is clicked with left mouse button
    % open a new figure and move the top FFT axis (including children) to
    % the new figure.
    topFig = figure('Units', 'pixels',...
    'Position', [200 200 1440 850]);
    topFig.CloseRequestFcn = @closeBigFigCallback; % call if figure is closed
    newTopAx = src; % create copy of axis that was clicked
    newTopAx.Parent = topFig; % move new axis into new figure
    newTopAx.OuterPosition = [0 0 1440 850]; % resize new axis
    newTopAx.ButtonDownFcn = ''; % get rid of: click to make new figure
  end

  function closeBigFigCallback(bigFig, ~)
    % if the big plot figure is closed, move the axis data back to the GUI
    % panel and delete the figure.    
    hFigAx = bigFig.CurrentAxes; % retreive the axis from calling figure
    
    hFigAx.Parent = FftPlotPanel; % move the axis back to the GUI
    
    figLoc = hFigAx.UserData; % figure out where the axis came from
    
    % put the axis back into the GUI in the right location
    switch figLoc
      case 'top'
        hFigAx.Position = topPos;
      case 'mid'
        hFigAx.Position = midPos;
      case 'bot'
        hFigAx.Position = botPos;
      otherwise
        warning('Unexpected plot type - unable to restore plot')
    end
    
    % re-enable: click for new big figure
    hFigAx.ButtonDownFcn = @clickAxCallback;
    
    delete(bigFig);
    updatePlot;
  end



end
  


  %%

%{

%% Time Domain Analysis
  
  % filter the recorded data matrix with high pass filter %%%%%%%%%%%%%%%
  accelFilt = HPfilter(sh.data,fs,fFilt);

  % get the accelerometer only data vectors
  acceleromDat = accelFilt(:,1:numAccels);

  % scale the accelerometer data to units of m/s^2
  accelCal = accelCalibrate(acceleromDat, sh.accelArray);

  % align the polarity of the accelerometer data to the coordinate axes
  acceleration = accelOrient(accelCal, sh.accelArray);
    
  if isShaker  
    % get the force sensor vector
    forceDat = accelFilt(:,forceCh);
    
    % calibrate force sensor data to units of Newtons
    forceDat = forceDat*sh.FSCalib;
  end
 
  clear accelCal acceleromDat accelFilt;

  % create displacement vectors from acceleration vector
  [~, displacement] = discIntgrt(acceleration,fs,fFilt);
   
  %% figure out if any known locations were measured 
  % find known accelerometer positions in locations M1, M2, coude, etc.
  
  % first find indices to all x, y, and z oriented accelerometers
  xIdx = find(strcmp(sh.accelArray{1,4}, 'x'));
  yIdx = find(strcmp(sh.accelArray{1,4}, 'y'));
  zIdx = find(strcmp(sh.accelArray{1,4}, 'z'));
  
  % find M1 accelerometers
  M1mxLocs = find(strcmp(sh.accelArray{1,3}, 'M1mx'));
  M1myLocs = find(strcmp(sh.accelArray{1,3}, 'M1my'));
  M1pxLocs = find(strcmp(sh.accelArray{1,3}, 'M1px'));
  
  numM1accels = numel(M1mxLocs) + numel(M1myLocs) + numel(M1pxLocs);
  if numM1accels == 9
    okM1 = true;
  elseif numM1accels == 0
    okM1 = false;
  else
    warning(['Expected 9 M1 accelerometers but only found ',...
      num2srt(numM1accels)])
  end
    
  % find M2 accelerometers
  M2mxLocs = find(strcmp(sh.accelArray{1,3}, 'M2mx'));
  M2myLocs = find(strcmp(sh.accelArray{1,3}, 'M2my'));
  M2pxLocs = find(strcmp(sh.accelArray{1,3}, 'M2px'));
    
  numM2accels = numel(M2mxLocs) + numel(M2myLocs) + numel(M2pxLocs);
  if numM2accels == 9
    okM2 = true;
  elseif numM2accels == 0
    okM2 = false;
  else
    warning(['Expected 9 M2 accelerometers but only found ',...
      num2srt(numM2accels)])
  end
  
  % find Coude accelerometers
  CmxLocs = find(strcmp(sh.accelArray{1,3}, 'Cmx'));
  CpxLocs = find(strcmp(sh.accelArray{1,3}, 'Cpx'));
  CmyLocs = find(strcmp(sh.accelArray{1,3}, 'Cmy'));
  CpyLocs = find(strcmp(sh.accelArray{1,3}, 'Cpy'));
  
  numCoudeAccels = numel(CmxLocs) + numel(CmyLocs) + numel(CpxLocs) +...
    numel(CpyLocs);
  if numCoudeAccels == 12
    okCoude = true;
  elseif numCoudeAccels == 0
    okCoude = false;
  else
    warning(['Expected 12 coude accelerometers but only found ',num2srt(numCoudeAccels)])
  end

  % find the individual accelerometer index using the orientations and
  % locations
  M1mxx = intersect(M1mxLocs,xIdx);
  M1mxy = intersect(M1mxLocs,yIdx);
  M1mxz = intersect(M1mxLocs,zIdx);
  M1myx = intersect(M1myLocs,xIdx);
  M1myy = intersect(M1myLocs,yIdx);
  M1myz = intersect(M1myLocs,zIdx);
  M1pxx = intersect(M1pxLocs,xIdx);
  M1pxy = intersect(M1pxLocs,yIdx);
  M1pxz = intersect(M1pxLocs,zIdx);
  Cmxx = intersect(CmxLocs, xIdx);
  Cmxy = intersect(CmxLocs, yIdx);
  Cmxz = intersect(CmxLocs, zIdx);
  Cpxx = intersect(CpxLocs, xIdx);
  Cpxy = intersect(CpxLocs, yIdx);
  Cpxz = intersect(CpxLocs, zIdx);
  Cmyx = intersect(CmyLocs, xIdx);
  Cmyy = intersect(CmyLocs, yIdx);
  Cmyz = intersect(CmyLocs, zIdx);
  Cpyx = intersect(CpyLocs, xIdx);
  Cpyy = intersect(CpyLocs, yIdx);
  Cpyz = intersect(CpyLocs, zIdx);
  
  %% transform displacement vectors into rigid body mirror motions if applicable
  
  %M1 = M1imageMotion(displacement);
  %M2 = M2imageMotion(displacement);
  %imagMotion = M1.imageMotion + M2.imageMotion;
  %imagMotion = displacement(:,15);
  
  if okCoude
    imCoude = convCoude(displacement,Cmxx,Cmxy,Cmxz,Cpxx,Cpxy,Cpxz,Cmyx,Cmyy,Cmyz,Cpyx,Cpyy,Cpyz);
  end
  
  if okM1
    imM1 = M1imageMotionLuke(displacement);
  end
  
  if okM2
    imM2 = convM2(); % not written yet
  end
    


if isShaker
  %% Frequency Domain Analysis
  [H1,H2,Gff,Gxx,Gfx,coherence,fvec] = Hcalc(forceDat,imagMotion,fs,fres,win);

  %% Structure Assembly and File Save
  SHKR.H1 = H1;
  SHKR.H2 = H2;
  SHKR.Gff = Gff;
  SHKR.Gxx = Gxx;
  SHKR.Gfx = Gfx;
  SHKR.coherence = coherence;
  SHKR.fvec = fvec;
  SHKR.fres = fres;
  SHKR.win = win;
  SHKR.shakerPos = shakerPos;
  SHKR.shakerOrient = shakerOrient;
  SHKR.shakerInfo = shakerInfo;
  SHKR.sourceFile = fileName;
  SHKR.imagMotion = imagMotion;

  %save([pathName shakerFileName],'SHKR'); % to save in same directory
  save(shakerFileName,'SHKR');
else
  
end

disp('ShakerCalcFRF complete');
%{    
amax = 1e-5;
amin = 1e-10;
for plotCnt = [4 6]   
    plotTitle = num2str(plotCnt);
    % calculate H1, H2, and the coherence vectors
    [H1,H2,coherence,fvec] = Hcalc(forceDat,displacement(:,plotCnt),fs,fres,win);
    plotFRF(H1,H2,coherence,fvec,fmin,fmax,fres,amax,amin,plotTitle);
    %savefig([shakerPos,char(plotCnt),'.fig'])
    %print(gcf,'-dpsc2'); % -dpsc2 is the color driver
end
%}


end

function [imagMotion] = convCoude(displacement,Cmxx,Cmxy,Cmxz,Cpxx,Cpxy,Cpxz,Cmyx,Cmyy,Cmyz,Cpyx,Cpyy,Cpyz)
%Written by Alex:
  
  % displacement is a vector with x, y, and z axis displacement data.
  % Adding and averaging the four reading locations increases accuracy.
  % The columns in displacement that have been selected correspond to
  % the axis in which the measurement was taken.
  xDisplacement = displacement(:,Cmxx) + displacement(:,Cpxx) + displacement(:,Cmyx) + displacement(:,Cpyx);
  xDisplacement = xDisplacement/4;
  
  yDisplacement = displacement(:,Cmxy) + displacement(:,Cpxy) + displacement(:,Cmyy) + displacement(:,Cpyy);
  yDisplacement = yDisplacement/4;
    
  zDisplacement = displacement(:,Cmxz) + displacement(:,Cpxz) + displacement(:,Cmyz) + displacement(:,Cpyz);
  zDisplacement = zDisplacement/4;
    
  % displacement angle cos(angle) = displacement(m)/5.1(m)
  % so displacment angle (milli-rad) = 1000 * acos(displacement(m)/5.1(m)
  xDispAng = 1000 .* acos(xDisplacement ./ 5.1);
  yDispAng = 1000 .* acos(yDisplacement ./ 5.1);
  zDispAng = 1000 .* acos(zDisplacement ./ 5.1);
    
  displacementVec = [xDispAng, yDispAng, zDispAng];
    
  % Image motion conversion matrix from Rob
  % imageMotionConversionMatrix = [0 27.817270 4.078854;0 -0.0000001
  % -11.825734]; old version
  imageMotionConversionMatrix = [0 18.43 4.08;0 -0.000001 -7.56]; % updated version
    
  % Store the image distortion in a 1x3 matrix, in units of milliarcsec
  xImageMotion = imageMotionConversionMatrix(1,:) * displacementVec';
  yImageMotion = imageMotionConversionMatrix(2,:) * displacementVec';
    
  % Transpose for neatness
  xImageMotion = xImageMotion';
  yImageMotion = yImageMotion';
   
  % Making imagMotion
  imagMotion = complex(xImageMotion,yImageMotion);

%}






